package xyz.pixelatedw.finalbeta.mixin;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import net.minecraft.level.LevelProperties;
import net.minecraft.util.io.CompoundTag;
import xyz.pixelatedw.finalbeta.WyHelper;

@Mixin(LevelProperties.class)
public class LevelPropertiesMixin {

	private long spawnTime;

	@Inject(method = "<init>", at = @At("TAIL"))
	public void settingSpawnTime(CompoundTag nbt, CallbackInfo ci) {
		if (!nbt.containsKey(WyHelper.SPAWN_TIME_TAG)) {
			this.spawnTime = System.currentTimeMillis();
		} else {
			this.spawnTime = nbt.getLong(WyHelper.SPAWN_TIME_TAG);
		}
		WyHelper.playTime = nbt.getLong(WyHelper.PLAY_TIME_TAG);
	}

	@Inject(method = "updateProperties", at = @At("TAIL"))
	public void updateSpawnTime(CompoundTag worldNbt, CompoundTag playerNbt, CallbackInfo ci) {
		worldNbt.put(WyHelper.SPAWN_TIME_TAG, this.spawnTime);
		worldNbt.put(WyHelper.PLAY_TIME_TAG, WyHelper.playTime);
	}
}
